MultiOverlayV2 = {};
MultiOverlayV2.modDir = g_currentModDirectory;
MultiOverlayV2.settingsDir = getUserProfileAppPath().. "moV2Hud_Settings/";
MultiOverlayV2.detiServerDir = getUserProfileAppPath();
MultiOverlayV2.artDesignDir = MultiOverlayV2.settingsDir.. "artDesign/";
MultiOverlayV2.fruitHudDir = MultiOverlayV2.settingsDir.. "fruitHud/";
MultiOverlayV2.gameDir = string.gsub(MultiOverlayV2.modDir, "MultiOverlayV2/", "");
MultiOverlayV2.saveGameDir = "";
MultiOverlayV2.pathSavegame = "";

MultiOverlayV2.metadata = {
	interface = " FS15 1.4.2",
	title = " MultiOverlay V2 Hud",
	notes = " Zeigt Aktuelle Preise/Bestände und vieles mehr in einem PDA Hud an",
	author = " (by HappyLooser)",
	version = " v2.3 BETA",
	versionXml = 0.1,
	versionArtDesign = 3,
	datum = " 31.08.2015",
	update = " 07.02.2016",
	web = " http://www.minetropolis.de/",
	info = " Link Freigabe,Änderungen,Kopien oder Code Benutzung ist ohne meine Zustimmung nicht erlaubt",
	"##Orginal Link Freigabe:  http://fs-uk.com/ (Mike3650)"
};

MultiOverlayV2.timerUpdate = { 
	id = nil;
	delay = 3600000; --1 hours
	updateDay = 0;
	wait = 0;
	first = true;
	interval = 112500; --1.875 min
	palSammler = 900000; --ca. 1/4 hours
	palSammlerTime = 0;
	isUpdate = false;
	isAutoSearch = false;
};

MultiOverlayV2.timerUpdateServer = { 
	id = nil;
	delay = 3600000; --1 hours
	updateDay = 0;
	wait = 0;
	first = true;
	interval = 112500; --1.875 min	
};

function MultiOverlayV2:loadMap(name)		
	print("---loading".. tostring(MultiOverlayV2.metadata.title).. tostring(MultiOverlayV2.metadata.version).. tostring(MultiOverlayV2.metadata.author).. "---")
	if not fileExists(MultiOverlayV2.settingsDir) then createFolder(MultiOverlayV2.settingsDir);end;	
	--local version = string.format("%.1f", Utils.getNoNil(MultiOverlayV2.metadata.versionXml, 0.0));	
	MultiOverlayV2.saveGameDir = MultiOverlayV2.settingsDir.. "savegame".. g_currentMission.missionInfo.savegameIndex.. "/"; 
	MultiOverlayV2.pathSavegame = g_currentMission.missionInfo:getSavegameDirectory(g_currentMission.missionInfo.savegameIndex);
	loadDefaultScripts(true);	
	if AAA_UniversalProcessKit ~= nil and AAA_UniversalProcessKit.UniversalProcessKit ~= nil then 
		moGeneralSettings.upkReady = true;		
	end;	
	--g_languageShort = "pl";
	MultiOverlayV2.language = "_".. string.lower(g_languageShort);	
	MultiOverlayV2.foundSettings = false;
	MultiOverlayV2.event = {greatDemand_s=false,discount_s=false,greatDemand_c=false,discount_c=false,info_s=true,infoEditUser_s=1,infoEditPw_s="1234",infoTable_s={},saveWeather_s=false,loadWeather_s=false,weatherDays_s={},weatherDaysString_s="",login=false,isMp=true,isMpUpdate=false};	
	self.greatDemand_s = MultiOverlayV2.event.greatDemand_s;
	self.discount_s = MultiOverlayV2.event.discount_s;
	self.saveWeather_s = MultiOverlayV2.event.saveWeather_s;
	self.weatherDaysString_s = MultiOverlayV2.event.weatherDaysString_s;
	self.info_s = MultiOverlayV2.event.info_s;
	self.infoEditUser_s = MultiOverlayV2.event.infoEditUser_s;
	self.infoEditPw_s = MultiOverlayV2.event.infoEditPw_s;
	MultiOverlayV2.loadError = false;
	MultiOverlayV2.loadHostServer = false;
	MultiOverlayV2.loadDetiServer = false;
	MultiOverlayV2.isMp = g_currentMission.missionDynamicInfo.isMultiplayer;
	MultiOverlayV2.isServer = false;	
	if g_server ~= nil then MultiOverlayV2.isServer = true;end;
	MultiOverlayV2.isClient = false;
	if g_client ~= nil then MultiOverlayV2.isClient = true;end;
	if MultiOverlayV2.isMp and MultiOverlayV2.isServer and MultiOverlayV2.isClient and g_dedicatedServerInfo == nil then MultiOverlayV2.loadHostServer = true;MultiOverlayV2.event.info_s=false;end;
	if MultiOverlayV2.isMp and MultiOverlayV2.isServer and MultiOverlayV2.isClient and g_dedicatedServerInfo ~= nil then MultiOverlayV2.loadDetiServer = true;MultiOverlayV2.event.info_s=false;end;
	if not MultiOverlayV2.loadDetiServer or MultiOverlayV2.loadHostServer then		
		moLanguageXml:loadTable(self);		
		moObjectXml:load(self);
	end;	
	--MultiOverlayV2.detiServerConnect = g_currentMission.connectedToDedicatedServer;	
	if MultiOverlayV2.loadDetiServer then
		print("!!!! DETISERVER !!!! Disabled" ..tostring(MultiOverlayV2.metadata.title).. " features for DetiServer(not Client)")		
		moXmlSettings:load(self, true, false, false, false);
		if MultiOverlayV2.event.saveWeather_s then			
			MultiOverlayV2:loadWeatherServer(self, false);
			MultiOverlayV2.timerUpdateServer.id = addTimer(1, "MultiOverlayV2.timerUpdateServer");
		end;
		return;
	end;	
	moXmlSettings:load(self, true, true, true, false);
	loadFirstFillTypesAndStationTriggers(self, false);	
	if MultiOverlayV2.loadError then
		print("!!!! WARNING !!!!".. tostring(MultiOverlayV2.metadata.title).. "has FillTypes Error.... stop Mod")
	else
		if not fileExists(MultiOverlayV2.artDesignDir) then	createFolder(MultiOverlayV2.artDesignDir);end;
		if not fileExists(MultiOverlayV2.fruitHudDir) then	createFolder(MultiOverlayV2.fruitHudDir);end;
		--preLoad
		if moDraw == nil then
			moDraw = {};
		end;
		if moGuiMiniPdaSlots.values ~= nil and moGuiMiniPdaSlots.values[1] ~= nil then
			moGuiMiniPdaSlots.values = {};
		end;
		--preLoad
		g_currentMission.modMultiOverlayUpdate = false;
		loadDefaultScripts(false);		
		loadDraws();
		moSetGetGui:moSetGetGuiLoadTables(self);		
		moXmlSettings:load(self, false, false, false, true);
		searchArtDesign(self);		
		moSetGetGui:loadAllOverlays(self);
		MultiOverlayV2:steerableLoad(self);		
		MultiOverlayV2.timerUpdate.id = addTimer(1, "MultiOverlayV2.timerUpdate");
		if MultiOverlayV2.loadHostServer and MultiOverlayV2.event.saveWeather_s then
			MultiOverlayV2:loadWeatherServer(self, false);
			MultiOverlayV2.timerUpdateServer.id = addTimer(1, "MultiOverlayV2.timerUpdateServer");
		end;
	end;		
end;

function MultiOverlayV2:deleteMap()	
	if MultiOverlayV2.loadDetiServer then		
		if MultiOverlayV2.timerUpdateServer.id ~= nil then
			removeTimer(MultiOverlayV2.timerUpdateServer.id)
		end;			
		return;
	end;
	saveLsHuds(self);
	if MultiOverlayV2.timerUpdate.id ~= nil then
		removeTimer(MultiOverlayV2.timerUpdate.id)
	end;
	if MultiOverlayV2.loadHostServer then
		if MultiOverlayV2.timerUpdateServer.id ~= nil then
			removeTimer(MultiOverlayV2.timerUpdateServer.id)
		end;
	end;
	MultiOverlayV2.timerUpdateServer.first = true;
	MultiOverlayV2.timerUpdateServer.updateDay = 0;
	MultiOverlayV2.timerUpdateServer.wait = 0;
	
	MultiOverlayV2:saveSettings(self, "clientSettings");
	MultiOverlayV2.timerUpdate.first = true;
	MultiOverlayV2.timerUpdate.updateDay = 0;
	MultiOverlayV2.timerUpdate.wait = 0;
	MultiOverlayV2.timerUpdate.palSammlerTime = 0;
	MultiOverlayV2.timerUpdate.isUpdate = false;
	MultiOverlayV2.timerUpdate.id = nil;
	MultiOverlayV2.loadError = false;
	MultiOverlayV2.loadHostServer = false;
	MultiOverlayV2.loadDetiServer = false;	
	moSetGetGui.deleteAllOverlays(self);
end;

function MultiOverlayV2:mouseEvent(posX, posY, isDown, isUp, button)	
	if MultiOverlayV2.loadDetiServer or g_currentMission.paused or g_currentMission.ingameMap.isFullSize then		
		return;
	end;	
	moSetGetKeyMouseEvent:setMouse(self, posX, posY, isDown, isUp, button);	
	moSetGetKeyMouseEvent:setKeyMouse(self, nil, nil, nil, nil, posX, posY, isDown, isUp, button)	
end;

function MultiOverlayV2:keyEvent(unicode, sym, modifier, isDown)	
	if MultiOverlayV2.loadDetiServer or g_currentMission.paused or g_currentMission.ingameMap.isFullSize then		
		return;
	end;
	if isDown then 
		--local testKey = TextInputElement.STATE_PRESSED;
		--g_gui.currentGui.fullScreenMode = true;
		--g_gui:showGui("MohHudV2_InfoGui");
		--g_gui:showGui("RafftnixGUI");
		--print("press test.........".. tostring(testKey))
	--	if unicode == 32 then end;
	--	print("press key.........".. tostring(string.char(unicode)))
	--	print("press unicode.........".. tostring(unicode))
	end;	
	moSetGetKeyMouseEvent:setKeyMouse(self, unicode, sym, modifier, isDown, nil, nil, nil, nil, nil)		
end;

function MultiOverlayV2:onCreateTextInput(element)
	local textInputElement = element;
	print("press key 1.........".. tostring(textInputElement))
end; --END onCreateTextInput()
	
function MultiOverlayV2:updateTick(dt)	
end;

function MultiOverlayV2:update(dt)	
	if g_server == nil and MultiOverlayV2.event.isMp then		
		MultiOverlayV2.event.isMp = false;
		MultiOverlayV2Event.sendEvent(self.greatDemand_s, self.discount_s, self.saveWeather_s, self.weatherDaysString_s, self.info_s, self.infoEditUser_s, self.infoEditPw_s, true);
	end;
	if MultiOverlayV2.loadDetiServer or g_currentMission.paused or g_currentMission.ingameMap.isFullSize then
		if MultiOverlayV2.loadDetiServer and MultiOverlayV2.timerUpdateServer.first then		
			MultiOverlayV2.timerUpdateServer.first = false;
			MultiOverlayV2.timerUpdateServer.wait = moGuiExtras:getMilliSecondsToHours(g_currentMission.environment.dayTime, false)*MultiOverlayV2.timerUpdateServer.delay;		
			MultiOverlayV2.timerUpdateServer.updateDay = g_currentMission.environment.currentDay;
			if MultiOverlayV2.event.saveWeather_s and not MultiOverlayV2.event.loadWeather_s then moGuiExtras:loadSaveWeather(self, false, true);end;
			if MultiOverlayV2.event.saveWeather_s and MultiOverlayV2.event.loadWeather_s then moGuiExtras:loadSaveWeather(self, true, true);end;
			MultiOverlayV2:saveWeatherServer(self, false)
		end;
		return;
	end;	
	if moGeneralSettings.setMouseCursor then InputBinding.setShowMouseCursor(true);end;
	if moGeneralSettings.setFrozen then g_currentMission.isPlayerFrozen = true;end;	
	if MultiOverlayV2.timerUpdate.first then		
		MultiOverlayV2.timerUpdate.first = false;
		reloadNewFillTypes(self);
		firstLoadMapObjects(self);
		--firstDisplayZoom(self);						
		MultiOverlayV2.timerUpdate.wait = moGuiExtras:getMilliSecondsToHours(g_currentMission.environment.dayTime, false)*MultiOverlayV2.timerUpdate.delay;		
		MultiOverlayV2.timerUpdate.updateDay = g_currentMission.environment.currentDay;		
		firstUpdates(self, false);		
		if zzzz_TriggerExtend ~= nil then			
			if zzzz_TriggerExtend.TriggerExtend.setSellMilk then
				moGeneralSettings.triggerExtend = true;			
			end;
		end;
		if ZZZ_courseplay ~= nil then moGeneralSettings.coursePlay = true;end;
		MultiOverlayV2:steerableLoad(self);		
		setFirstLsHuds(self);		
		if not MultiOverlayV2.isMp then
			if MultiOverlayV2.event.saveWeather_s and not MultiOverlayV2.event.loadWeather_s then moGuiExtras:loadSaveWeather(self, false, false);end;
			if MultiOverlayV2.event.saveWeather_s and MultiOverlayV2.event.loadWeather_s then moGuiExtras:loadSaveWeather(self, true, false);end;
		end;	
		if MultiOverlayV2.loadHostServer then			
			if MultiOverlayV2.timerUpdateServer.first then		
				MultiOverlayV2.timerUpdateServer.first = false;
				MultiOverlayV2.timerUpdateServer.wait = moGuiExtras:getMilliSecondsToHours(g_currentMission.environment.dayTime, false)*MultiOverlayV2.timerUpdateServer.delay;		
				MultiOverlayV2.timerUpdateServer.updateDay = g_currentMission.environment.currentDay;
				if MultiOverlayV2.event.saveWeather_s and not MultiOverlayV2.event.loadWeather_s then moGuiExtras:loadSaveWeather(self, false, true);end;
				if MultiOverlayV2.event.saveWeather_s and MultiOverlayV2.event.loadWeather_s then moGuiExtras:loadSaveWeather(self, true, true);end;
				MultiOverlayV2:saveWeatherServer(self, false)
			end;
		end;		
		moSetGetGui:loadWeatherImages(self, false);
		--testFunction(self);		
		return;
	end;
end;

function MultiOverlayV2:draw()		
	if MultiOverlayV2.loadDetiServer or moSetGetGui.loadImages.refreshAll then		
		return;
	end;	
	if g_currentMission.ingameMap.isFullSize == true or g_currentMission.paused then 
		removeViPda(self);		
		return true; 
	end;
	if moGuiMiniPdaSlots.fieldsInfo.isUpdate and not moGuiMiniPdaSlots.fieldsInfo.isUpdateWorldAreas and moGuiMiniPdaSlots.fieldsInfo.calculation == 3 then		
		renderText(0.4, 0.5, 0.023, tostring("Wait...... first scan ".. tostring(moGuiMiniPdaSlots.fieldsInfo.isUpdateWorldAreasScan).. "(3)"));		
		renderText(0.4, 0.48, 0.014, tostring(moGuiMiniPdaSlots.fieldsInfo.isUpdateWorldAreasScanText));
		setOpenFieldUpdateAreas();		
		return true;
	end;
	if moGuiMiniPdaSlots.fieldsInfo.seeFieldPlayerLocation then
		setOpenPlayerFieldLocation();
		if string.len(moGuiMiniPdaSlots.fieldsInfo.fieldPlayerLocationTxt) > 0 then
			renderText(0.02, 0.01, 0.012, tostring(moGuiMiniPdaSlots.fieldsInfo.fieldPlayerLocationTxt));
		end;
	end;
	--if moVehicles ~= nil and moVehicles[2].object ~= nil then
	--	local xmlVehicle = string.lower(moVehicles[2].object.configFileName);
	--	local StoreItem = StoreItemsUtil.storeItemsByXMLFilename[xmlVehicle];
	--	local storeImage = createImageOverlay(Utils.getFilename(StoreItem.imageActive));
	--	renderOverlay(storeImage, 0.3, 0.4, 0.05, 0.05);
	--end;
	function setHotSpot()
		if moGuiMiniPdaSlots.isHotSpotObj then				
			moGuiMiniPdaSlots.hotSpotEnd = moGuiMiniPdaSlots.hotSpotEnd-1
			if moGuiMiniPdaSlots.hotSpotEnd <= 5 or moGuiMiniPdaSlots.hotSpotSlot ~= moGuiMiniPdaSlots.keySwitchLast then moGuiMiniPdaSlots.isHotSpotObj = false;moGuiMiniPdaSlots.hotSpotEnd = 500;moSetGetGui:setGetHotSpotMap(self, false, false);end;				
		end;
	end;
	if moGuiMiniPdaSlots.isActive then	
		if moGuiMiniPdaSlots.activeTotal ~= 0 and moSetGetGui.loadImages.slots and not moGuiMiniPdaSlots.isHiden then				
			for a=1, moGuiMiniPdaSlots.activeTotal do
				moSetGetGui["slot".. a]:render();
				moSetGetGui["keySwitch"]:render();
				setSlotNotReadyFoundObjects(self, a);				
				if moGuiMiniPdaSlots.values[a].isOpen and not moSetGetGui.cfgMenue.all and not moSetGetGui.isActivePage then
					setOpenMiniPdaSlot(self, a);
				end;				
			end;
			setSlotWarningMiniPda(self);
			setHotSpot();
			if moGuiMiniPdaSlots.isSeeSmallDraw then
				moGuiMiniPdaSlots.seeSmallDrawEnd = moGuiMiniPdaSlots.seeSmallDrawEnd-1
				moDraw["seeSmall"]:setOpenSlot(self);
				if moGuiMiniPdaSlots.seeSmallDrawEnd <= 5 then moGuiExtras:disableExtraDraws(self, true, false);end;
			end;
			if moGuiMiniPdaSlots.fieldsInfo.isExtraDraw then				
				moDraw["extraFields"]:setOpenField(self);
				if moGuiMiniPdaSlots.fieldsInfo.autoCloseExtraDraw then
					moGuiMiniPdaSlots.fieldsInfo.extraDrawEnd = moGuiMiniPdaSlots.fieldsInfo.extraDrawEnd-1
					if moGuiMiniPdaSlots.fieldsInfo.extraDrawEnd <= 5 then moGuiExtras:disableExtraDraws(self, false, true);end;
				end;				
			end;
			if moGuiMiniPdaSlots.isFieldBuyTrigger then
				moGuiMiniPdaSlots.fieldBuyEnd = moGuiMiniPdaSlots.fieldBuyEnd-1
				if moGuiMiniPdaSlots.fieldBuyEnd <=5 then moGuiMiniPdaSlots.isFieldBuyTrigger = false;end;
			end;
		end;
	end;
	if moSetGetGui.loadImages.defaultWeather and moSetGetGui.wtmHud.mohHud and not moSetGetGui.wtmHud.on and not moSetGetGui.wtmHud.isHiden then
		moDraw.wtmHud:setOpenWtmHud(self);
		if moSetGetGui.wtmHud.isSeePreviewWeather then
			moSetGetGui.wtmHud.seePreviewWeatherEnd = moSetGetGui.wtmHud.seePreviewWeatherEnd-1
			if moSetGetGui.wtmHud.seePreviewWeatherEnd <= 5 then
				moGuiExtras:disableExtraDraws(self, false, false, true);
			else
				moDraw.wtmHud:setOpenPreviewWeather(self);
			end;
		elseif moSetGetGui.wtmHud.isSeePreviewMoneyChangeLast then
			moSetGetGui.wtmHud.seePreviewMoneyChangeLastEnd = moSetGetGui.wtmHud.seePreviewMoneyChangeLastEnd-1
			if moSetGetGui.wtmHud.seePreviewMoneyChangeLastEnd <=5 then
				moGuiExtras:disableExtraDraws(self, false, false, false, true);
			else
				moDraw.wtmHud:setOpenPreviewMoneyChangeLast(self);
			end;
		end;
	end;
	if moSetGetGui.isActivePage and moSetGetGui.loadImages.pages and not moSetGetGui.cfgMenue.all then
		moDraw["pageMenue"]:setOpen(self);
		setOpenPage(self);
		setHotSpot();
	end;
	if moSetGetGui.cfgMenue.all and moSetGetGui.loadImages.cfgMenues then
		moDraw["cfgMenue"]:setOpen(self, nil);		
	end;
	if moSetGetGui.dragDropPos then				
		moSetGetGui["newPosRahmen"]:render();		
	end;
	if moSetGetGui.pdaVI.on then
		if not moSetGetGui.pdaVI.isHiden and not moSetGetGui.pdaVI.cfg or (moSetGetGui.pdaVI.cfg and moSetGetGui.pdaVI.cfgHiden) then
			MultiOverlayV2:setOpenViPDA(self);
		end;
	end;	
	if moGeneralSettings.testNumber ~= 0 then
		renderText(0.3, 0.22, 0.012, tostring(moGeneralSettings.testNumber));
	end;
	if string.len(moGeneralSettings.testString) > 0 then
		renderText(0.3, 0.20, 0.012, tostring(moGeneralSettings.testString));
	end;	
	--moSetGetGui["viCfg"]:render();moSetGetGui["seeds"]:setPosition(0.3, 0.2);
	--moSetGetGui["seeds"]:render();
	--moSetGetGui["okay"]:render();	
	--respect settings for other mods
	setTextAlignment(false);
	setTextColor(1, 1, 1, 1);
	setTextBold(false);
	--respect settings for other mods	
end;
addModEventListener(MultiOverlayV2);

-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

function setOpenFieldUpdateAreas()
	if not moGuiMiniPdaSlots.fieldsInfo.isUpdateWorldAreas and moGuiMiniPdaSlots.fieldsInfo.calculation == 3 then
		moGuiMiniPdaSlots.fieldsInfo.isUpdateWorldAreasScanTime = moGuiMiniPdaSlots.fieldsInfo.isUpdateWorldAreasScanTime+1;
		if moGuiMiniPdaSlots.fieldsInfo.isUpdateWorldAreasScanTime > 5 then
			if moGuiMiniPdaSlots.fieldsInfo.isUpdateWorldAreasScan == 1 and moGuiMiniPdaSlots.fieldsInfo.isUpdateWorldAreasScanReady[1] == false then				
				moGuiMiniPdaSlots.fieldsInfo.isUpdateWorldAreasScanReady[1] = true;
				testFunction1(true, false, false);
			elseif moGuiMiniPdaSlots.fieldsInfo.isUpdateWorldAreasScan == 2 and moGuiMiniPdaSlots.fieldsInfo.isUpdateWorldAreasScanReady[2] == false then	
				moGuiMiniPdaSlots.fieldsInfo.isUpdateWorldAreasScanReady[2] = true;
				testFunction1(false, true, false);
			elseif moGuiMiniPdaSlots.fieldsInfo.isUpdateWorldAreasScan == 3 and moGuiMiniPdaSlots.fieldsInfo.isUpdateWorldAreasScanReady[3] == false then		
				moGuiMiniPdaSlots.fieldsInfo.isUpdateWorldAreasScanReady[3] = true;
				testFunction1(false, false, true);			
			end;
		end;
	end;
end;

function setOpenPlayerFieldLocation()
	local fieldTable = nil;
	if moGuiMiniPdaSlots.fieldsInfo.calculation == 3 and moFieldDefNew ~= nil and moFieldDefNew[1] ~= nil then fieldTable = moFieldDefNew;end;
	if moGuiMiniPdaSlots.fieldsInfo.calculation == 2 and moFieldData ~= nil and moFieldData[1] ~= nil then fieldTable = moFieldData;end;
	if moGuiMiniPdaSlots.fieldsInfo.calculation == 1 and moFieldDef ~= nil and moFieldDef[1] ~= nil then fieldTable = moFieldDef;end;
	if fieldTable ~= nil and moGuiMiniPdaSlots.fieldsInfo.calculation ~= 2 then	
		local x, _, z = getWorldTranslation(g_currentMission.player.rootNode)
		if x ~= nil and z ~= nil then			
			local fieldNum = 0;	
			for field,fieldDef in ipairs(fieldTable) do
				for _,tableValues in ipairs(fieldDef) do			
					if tableValues.x1 <= x and x <= tableValues.x2 and tableValues.z1 <= z and z <= tableValues.z2 then				
						if moGuiMiniPdaSlots.fieldsInfo.calculation == 3 then
							moGuiMiniPdaSlots.fieldsInfo.fieldPlayerLocationTxt = "Field ".. tostring(moFieldDefNew[field].fieldNum);
						elseif moGuiMiniPdaSlots.fieldsInfo.calculation == 1 then
							moGuiMiniPdaSlots.fieldsInfo.fieldPlayerLocationTxt = "Field ".. tostring(field);
						end;						
						fieldNum = 1;
						break;
					else
						moGuiMiniPdaSlots.fieldsInfo.fieldPlayerLocationTxt = "";						
					end;			
				end;
				if fieldNum ~= 0 then break;end;
			end;		
		end;
	end;
	if fieldTable ~= nil and moGuiMiniPdaSlots.fieldsInfo.calculation == 2 then	
		local x, _, z = getWorldTranslation(g_currentMission.player.rootNode)
		if x ~= nil and z ~= nil then			
			local fieldNum = 0;
			for field,fieldDef in ipairs(fieldTable) do							
				if fieldTable[field].startX <= x and x <= fieldTable[field].endX and fieldTable[field].startZ <= z and z <= fieldTable[field].endZ then				
					moGuiMiniPdaSlots.fieldsInfo.fieldPlayerLocationTxt = "Field ".. tostring(field);						
					fieldNum = 1;
					break;
				else
					moGuiMiniPdaSlots.fieldsInfo.fieldPlayerLocationTxt = "";						
				end;
				if fieldNum ~= 0 then break;end;
			end;
		end;			
	end;
end;

function setOpenMiniPdaSlot(self, slot)	
	local drawName = moGuiMiniPdaSlots.values[slot].name;	
	if moDraw[drawName] ~= nil then			
		moDraw[drawName]:setOpenPdaSlot(self, slot, drawName);
		if moGuiMiniPdaSlots.values[slot].settings then
			moDraw["cfgMenue"]:setOpen(self, slot);
		end;
	else
		if tostring(drawName) == "silagesilos" and moDraw["bga"] ~= nil then	
			moDraw["bga"]:setOpenPdaSlot(self, slot, drawName);
			if moGuiMiniPdaSlots.isSlotCfg and moGuiMiniPdaSlots.values[slot].settings then
				moDraw["cfgMenue"]:setOpen(self, slot);
			end;
			return;
		else
			if moDraw["slots"] ~= nil then
				moDraw["slots"]:setOpenPdaSlot(self, slot, drawName);
				if moGuiMiniPdaSlots.isSlotCfg and moGuiMiniPdaSlots.values[slot].settings then
					moDraw["cfgMenue"]:setOpen(self, slot);
				end;
				return;
			end;			
		end;
		moGuiExtras:closeOpenSlot(self, slot, true, false);				
		g_currentMission:showBlinkingWarning("not found moDraw.".. tostring(drawName).. ".lua (if error !!)", 2000);		
	end;	
end;

function setSlotNotReadyFoundObjects(self, slot)
	if moGuiMiniPdaSlots.values[slot].foundObjects == 0 then
		moSetGetGui["notReadySlot"]:setPosition(moGuiMiniPdaSlots.values[slot].posX, moGuiMiniPdaSlots.values[slot].posY);
		moSetGetGui["notReadySlot"]:render();
	end;
end;

function setOpenPage(self)	
	if moSetGetGui.activePage == 1 and not moSetGetGui.page[1].isHiden then
		moDrawPage1:setOpenPage(self);
	elseif moSetGetGui.activePage == 2 then 
		if not moSetGetGui.page[2].isHiden then
			moDrawPage2:setOpenPage(self);
		end;
		if moSetGetGui.page[2].switch == 3 and moSetGetGui.page[2].mboBuyShowGui then
			if moSetGetGui.page[2].mboBuyShowTimer > moSetGetGui.page[2].mboBuyShowTimerMax then		
				moGuiExtras:disableMboBuyShowGui(self);				
			else
				moSetGetGui.page[2].mboBuyShowTimer = moSetGetGui.page[2].mboBuyShowTimer+1;
			end;
		end;
	elseif moSetGetGui.activePage == 3 and not moSetGetGui.page[3].isHiden then
		moDrawPage3:setOpenPage(self);
	end;	
end;

function setSlotWarningMiniPda(self)	
	if moSetGetGui.loadImages.warnings then --and moGuiMiniPdaSlots.values[slot].isWarning == 2 and moGuiMiniPdaSlots.values[slot].foundObjects > 0 then							
		moDrawWarnings:setGet(self);		
	end;	
end;

function setStationUpdate(self, all)	
	moSetGetStationes:setStationUpdate(self, all);
end;

function setDemandSalesUpdate(self)	
	if MultiOverlayV2.isMp or MultiOverlayV2.loadHostServer then
		if MultiOverlayV2.event.greatDemand_s and MultiOverlayV2.event.greatDemand_c then
			moSetGetDemandSales:setDemandSalesUpdate(self, true, false);
		end;
		if MultiOverlayV2.event.discount_s and MultiOverlayV2.event.discount_c then
			moSetGetDemandSales:setDemandSalesUpdate(self, false, true);
		end;
	else
		if MultiOverlayV2.event.greatDemand_c then
			moSetGetDemandSales:setDemandSalesUpdate(self, true, false);
		end;
		if MultiOverlayV2.event.discount_c then
			moSetGetDemandSales:setDemandSalesUpdate(self, false, true);
		end;
	end;	
end;

function MultiOverlayV2:setSlotUpdate(self, slot, first)
	if first == nil and not moGuiMiniPdaSlots.values[slot].isOpen then return;end;
	local slotName = MultiOverlayV2:getSlotName(slot);	
	if first then 
		if slotName == "amount" then moGuiMiniPdaSlots.values[slot].foundObjects = moGeneralSettings.Fillable_NUM_FILLTYPES;return;end;
		if slotName == "bestprice" then moGuiMiniPdaSlots.values[slot].foundObjects = 3;return;end;		
	end;
	if slotName == "amount" or slotName == "bestprice" or slotName == "shop1" or slotName == "shop2" then return;end;
	if slotName == "bga" or slotName == "silagesilos" then moSetGetBga:setBgaUpdate(self, slot, slotName);return;end;
	if slotName == "fieldsprice" or slotName == "fieldsinfo" then moSetGetFields:setFieldsPriceUpdate(self, slot, slotName);return;end;
	moSetGetSlotObjects:setUpdate(self, slot, slotName);
end;

function MultiOverlayV2:mouseIsInArea(mouseX, mouseY, areaX1, areaX2, areaY1, areaY2)
	return mouseX >= areaX1 and mouseX <= areaX2 and mouseY >= areaY1 and mouseY <= areaY2;
end;

function MultiOverlayV2:getSlot(slotName)
	local slotActiveName = Utils.splitString(" ", moGuiMiniPdaSlots.activeName);
	local slot = 0;			
	for a=1, table.getn(slotActiveName) do
		if slotActiveName[a] == slotName then 
			slot = a;					
			break;
		end;
	end;
	return slot;
end;

function MultiOverlayV2:getSlotName(slot)
	--local slotActiveName = Utils.splitString(" ", moGuiMiniPdaSlots.activeName);
	local slotName = "";			
	--for a=1, table.getn(slotActiveName) do
	--	if a == slot then 
	--		slotName = slotActiveName[a];					
	--		break;
	--	end;
	--end;
	if moGuiMiniPdaSlots.values[slot].name ~= nil then slotName = moGuiMiniPdaSlots.values[slot].name;end;
	return slotName;
end;

function loadFirstFillTypesAndStationTriggers(self)
	moSetGetFillTypes:setFirstFillTypes(self);
	moSetGetStationes:setFirstStationTriggers(self);
end;

function firstLoadMapObjects(self)
	moSetGetMapObjects:searchFirstMapObjects(self);
end;

function reloadNewFillTypes(self)
	if moGeneralSettings.Fillable_NUM_FILLTYPES ~= Fillable.NUM_FILLTYPES then
		moSetGetFillTypes:setFirstFillTypes(self, true);
	end;
	if moSetGetGui.vsHud.newFruitHuds then moGuiExtras:newFruitHudsLoad(self);end;
	moSetGetFillTypes:setFirstFruitTypes(self);
end;

function firstUpdates(self, isActive)
	if not isActive then
		setStationUpdate(self, true);
		moSetGetBga:setFirstBgaUpdate(self);		
		setDemandSalesUpdate(self);
		moSetGetFields:setFieldsDefination(self);
		moSetGetFields:setFieldsAndFruitsValues(self)
		if not moGeneralSettings.multiFarm and moGeneralSettings.multiFarmSilo > 0 or moGeneralSettings.multiFarm and moGeneralSettings.multiFarmFound == 0 then moGeneralSettings.multiFarmSilo = 0;moGeneralSettings.multiFarm = false;end;
	end;
	if moGuiMiniPdaSlots.isActive and moGuiMiniPdaSlots.activeTotal > 0 then
		for a=1, moGuiMiniPdaSlots.activeTotal do
			MultiOverlayV2:setSlotUpdate(self, a, true);
		end;
	end;	
end;

function timerUpdateServer(self)
	if MultiOverlayV2.timerUpdateServer.id == nil then return;end;
	if g_currentMission ~= nil and MultiOverlayV2.event.saveWeather_s then
		if MultiOverlayV2.timerUpdateServer.updateDay ~= g_currentMission.environment.currentDay then
			MultiOverlayV2.timerUpdateServer.updateDay = g_currentMission.environment.currentDay;
			if not MultiOverlayV2.timerUpdateServer.first and MultiOverlayV2.event.loadWeather_s then moGuiExtras:loadSaveWeather(self, false, true);end;
			MultiOverlayV2:saveSettings(self, "serverWeatherSettings"); --hours save
		end;		
		setTimerTime(MultiOverlayV2.timerUpdateServer.id, MultiOverlayV2.timerUpdateServer.interval);
		return true;
	end;
end;

function timerUpdate(self)	
	if MultiOverlayV2.timerUpdate.id == nil then return;end;
	if not MultiOverlayV2.timerUpdate.isUpdate and g_currentMission ~= nil then
		MultiOverlayV2.timerUpdate.isUpdate = true;
		local currentTime = g_currentMission.environment.dayTime;		
		if MultiOverlayV2.timerUpdate.updateDay ~= g_currentMission.environment.currentDay then
			MultiOverlayV2.timerUpdate.updateDay = g_currentMission.environment.currentDay;			
			if moGeneralSettings.palSammler or moGeneralSettings.wollPalCollector then
				if MultiOverlayV2.isMp and not MultiOverlayV2.loadHostServer then
					MultiOverlayV2.timerUpdate.palSammlerTime = currentTime+MultiOverlayV2.timerUpdate.palSammler;				
					moGuiExtras:updateFillablePallet(self);				
				end;
			end;			
			if not MultiOverlayV2.isMp and not MultiOverlayV2.timerUpdate.first and MultiOverlayV2.event.saveWeather_s and MultiOverlayV2.event.loadWeather_s then moGuiExtras:loadSaveWeather(self, false, false);end;
			if moSetGetGui.wtmHud.mohHud then moSetGetGui:loadWeatherImages(self, true);end;
			MultiOverlayV2:saveSettings(self, "clientSettings"); --hours save			
			setStationUpdate(self, true);			
		else			
			if moGeneralSettings.palSammler or moGeneralSettings.wollPalCollector then
				if MultiOverlayV2.isMp and not MultiOverlayV2.loadHostServer then
					if MultiOverlayV2.timerUpdate.palSammlerTime <= currentTime then
						MultiOverlayV2.timerUpdate.palSammlerTime = currentTime+MultiOverlayV2.timerUpdate.palSammler;					
						moGuiExtras:updateFillablePallet(self);								
					end;
				end;
			end;
			setStationUpdate(self, false);			
		end;
		setDemandSalesUpdate(self);		
		if moGuiMiniPdaSlots.isActive and moGuiMiniPdaSlots.activeTotal > 0 and not MultiOverlayV2.timerUpdate.first and not moGuiMiniPdaSlots.isHiden then
			for a=1, moGuiMiniPdaSlots.activeTotal do
				if not moGuiMiniPdaSlots.values[a].permUpdate then
					MultiOverlayV2:setSlotUpdate(self, a);
				end;
			end;
		end;
		MultiOverlayV2.timerUpdate.isUpdate = false;
		setTimerTime(MultiOverlayV2.timerUpdate.id, MultiOverlayV2.timerUpdate.interval);		
		return true;	
	end;
end;

function MultiOverlayV2:saveSettings(self, settingsFile)
	if settingsFile == "clientSettings" then moSetGetConfigXml:saveConfig(self);end;
	if settingsFile == "serverWeatherSettings" then MultiOverlayV2:saveWeatherServer(self, false);end;	
end;

function setFirstLsHuds(self)
	moSetGetGui.wtmHud.binding = Utils.getNoNil(getKeyIdOfModifier(InputBinding.MoV2WtmHud, false));
	moSetGetGui.vsHud.binding = Utils.getNoNil(getKeyIdOfModifier(InputBinding.MoV2VsHud, false));
	moSetGetGui.miniMap.binding = Utils.getNoNil(getKeyIdOfModifier(InputBinding.MoV2MiniMap, false));
	if moSetGetGui.wtmHud.binding then 
		if not moSetGetGui.wtmHud.on or moSetGetGui.wtmHud.mohHud then
			moGuiExtras:setGetWtmHud(self, false);		
		end;		
	elseif moSetGetGui.wtmHud.mohHud then
		moGuiExtras:setGetWtmHud(self, false);
	end;
	if not moSetGetGui.helpText then moGuiExtras:setGetHelpText(self, false);end;
	if moSetGetGui.miniMap.binding and not moSetGetGui.miniMap then moGuiExtras:setGetMiniMap(self, false);end;
	if moSetGetGui.vsHud.binding and not moSetGetGui.vsHud then moGuiExtras:setGetVsHud(self, false);end;
	if moSetGetGui.vsHud.fruitNamesOn or moSetGetGui.vsHud.fillPriceOn then moGuiExtras:fruitNamesOnLoad(self);end;
end;

function saveLsHuds(self)	
	--if moSetGetGui.closeAllHud then 
	--moGuiExtras:setGetCloseAllHud(self, 0, true);
	--end;
	if moGuiMiniPdaSlots.isActive and moGuiMiniPdaSlots.values ~= nil and moGuiMiniPdaSlots.values[moGuiMiniPdaSlots.keySwitchLast] ~= nil then
		if moGuiMiniPdaSlots.values[moGuiMiniPdaSlots.keySwitchLast].isOpen and moGuiMiniPdaSlots.values[moGuiMiniPdaSlots.keySwitchLast].closeAllHud then
			moGuiExtras:setGetCloseAllHud(self, moGuiMiniPdaSlots.keySwitchLast, true);
		end;
	end;
	if not g_currentMission.showHelpText then 
		moSetGetGui.helpText = false;
	else
		moSetGetGui.helpText = true;
	end;
	if moSetGetGui.miniMap.binding and not g_currentMission.ingameMap.isVisible then
		moSetGetGui.miniMap.on = false;
	else
		moSetGetGui.miniMap.on = true;
	end;
	if moSetGetGui.wtmHud.binding and not g_currentMission.showWeatherForecast then
		moSetGetGui.wtmHud.on = false;
	elseif moSetGetGui.wtmHud.mohHud then
		moSetGetGui.wtmHud.on = false;
	else
		moSetGetGui.wtmHud.on = true;
	end;
	if moSetGetGui.vsHud.binding and not g_currentMission.showVehicleSchema then
		moSetGetGui.vsHud.on = false;
	else
		moSetGetGui.vsHud.on = true;
	end;
end;

function MultiOverlayV2:setOpenViPDA(self)
	if moSetGetGui.pdaVI.autoPos == 0 then
		if g_currentMission.showHelpText and g_currentMission.hudHelpContentOverlay.y ~= 0 then
			if moSetGetGui.pdaVI.hideSwitch == 2 then removeViPda(self);return;end;
			moSetGetGui.pdaVI.posY = g_currentMission.hudHelpContentOverlay.y;
			if g_currentMission.hudHelpTextLineSpacing ~= 0 then moSetGetGui.pdaVI.posY = moSetGetGui.pdaVI.posY - g_currentMission.hudHelpTextLineSpacing*2;end;
		else
			if moSetGetGui.pdaVI.hideSwitch == 1 then removeViPda(self);return;end;
			moSetGetGui.pdaVI.posY = 0.994;			
		end;
	elseif moSetGetGui.pdaVI.autoPos == 1 then
		if g_currentMission.ingameMap.isVisible then
			if moSetGetGui.pdaVI.hideSwitch == 2 then removeViPda(self);return;end;
			moSetGetGui.pdaVI.posY = g_currentMission.ingameMap.minMapHeight + 0.02;
		else
			if moSetGetGui.pdaVI.hideSwitch == 1 then removeViPda(self);return;end;
			moSetGetGui.pdaVI.posY = 0.002;			
		end;
	end;
	if moSetGetGui.pdaVI.iconDesign and not moSetGetGui.loadImages.vi then
		g_currentMission:showBlinkingWarning("not found VI Icons".. tostring("(set TextDesign)"), 2000);
		moSetGetGui.pdaVI.distanceLine = false;
		moSetGetGui.pdaVI.iconDesign = false;
	end;
	if moDraw.vehicles ~= nil then moDraw.vehicles:setOpenPDA(self);end;	
end;

function removeViPda(self)
	if moVehicles ~= nil then table.remove(moVehicles);end;	
end;

function searchArtDesign(self)	
	moSetGetArtDesign:searchArtDesign(self);
end;

function MultiOverlayV2:steerableLoad(self)
	local name = {"vehicle.name.".. g_languageShort, "vehicle.name.en", "vehicle.name", "vehicle#type"};
	if Steerable.load ~= nil then 
		local orgSteerableLoad = Steerable.load 
		Steerable.load = function(self,xmlFile) orgSteerableLoad(self,xmlFile) 
			for key,XMLPath in pairs(name) do 
				self.name = getXMLString(xmlFile, XMLPath); 
				if self.name ~= nil then 
					break; 
				end; 
			end; 
			if self.name == nil then 
				self.name = g_i18n:getText("Unknown") 
			end; 
		end; 
	end; 
	if Attachable.load ~= nil then 
		local orgAttachableLoad = Attachable.load 
		Attachable.load = function(self,xmlFile) orgAttachableLoad(self,xmlFile) 
			for key,XMLPath in pairs(name) do 
				self.name = getXMLString(xmlFile, XMLPath); 
				if self.name ~= nil then 
					break; 
				end; 
			end; 
			if self.name == nil then 
				self.name = g_i18n:getText("Unknown") 
			end; 
		end; 
	end; 
end;

function getKeyIdOfModifier(binding)
    local bindingFound = nil;
	for key, value in pairs(InputBinding.actions[binding]) do		
		if key == "keys1" or key == "keys2" or key == "mouseButtons" or key == "gamepadButtons" then
			bindingFound = value[1];
			if bindingFound ~= nil then break;end;
		end;
	end;
    return bindingFound;
end

---coursePlay onFoot
function MultiOverlayV2.drawMouseButtonHelp(self, posY, txt)
	local xLeft = g_currentMission.hudHelpTextPosX1;
	local xRight = g_currentMission.hudHelpTextPosX2;

	local ovl = moSetGetGui["mouse6"]
	if ovl then
		local y = posY - g_currentMission.hudHelpTextSize - g_currentMission.hudHelpTextLineSpacing*3;
		ovl:setPosition(xLeft - ovl.width*0.2, y);
		ovl:render();
		--xLeft = xLeft + ovl.width*0.6;
	end;

	posY = posY - g_currentMission.hudHelpTextSize - g_currentMission.hudHelpTextLineSpacing*2;
	setTextAlignment(RenderText.ALIGN_RIGHT);
	renderText(xRight, posY, g_currentMission.hudHelpTextSize, txt);

	--setTextAlignment(RenderText.ALIGN_LEFT);
	--renderText(xLeft, posY, g_currentMission.hudHelpTextSize, "Click");
end;
--coursePlay onFoot

function loadDraws()
	source(MultiOverlayV2.modDir.."scripte/draw/moDrawCfgMenue.lua");
	source(MultiOverlayV2.modDir.."scripte/draw/moDrawPageMenue.lua");
	source(MultiOverlayV2.modDir.."scripte/draw/moDrawVehicles.lua");
	source(MultiOverlayV2.modDir.."scripte/draw/moDrawBga.lua");
	source(MultiOverlayV2.modDir.."scripte/draw/moDrawFieldsPrice.lua");
	source(MultiOverlayV2.modDir.."scripte/draw/moDrawAmount.lua");
	source(MultiOverlayV2.modDir.."scripte/draw/moDrawBestPrice.lua");
	source(MultiOverlayV2.modDir.."scripte/draw/moDrawWarnings.lua");
	source(MultiOverlayV2.modDir.."scripte/draw/moDrawSlots.lua");
	source(MultiOverlayV2.modDir.."scripte/draw/moDrawSeeSmall.lua");
	source(MultiOverlayV2.modDir.."scripte/draw/moDrawFieldsInfo.lua");
	source(MultiOverlayV2.modDir.."scripte/draw/moDrawExtraFields.lua");
	source(MultiOverlayV2.modDir.."scripte/draw/moDrawWtmHud.lua");
end;

function loadDefaultScripts(first)
	if first then
		source(MultiOverlayV2.modDir.."defaultSettings/moLoadTables.lua");		
		source(MultiOverlayV2.modDir.."defaultSettings/moLanguageXml.lua");		
		source(MultiOverlayV2.modDir.."defaultSettings/moObjectXml.lua");		
		source(MultiOverlayV2.modDir.."defaultSettings/moXmlSettings.lua");	
		source(MultiOverlayV2.modDir.."defaultSettings/moSetGetConfigXml.lua");
		source(MultiOverlayV2.modDir.."scripte/moSetGetFillTypes.lua");		
		source(MultiOverlayV2.modDir.."scripte/moSetGetStationes.lua");
		source(MultiOverlayV2.modDir.."scripte/moGuiExtras.lua");
	else		
		source(MultiOverlayV2.modDir.."scripte/moSetGetMapObjects.lua");		
		source(MultiOverlayV2.modDir.."scripte/mouseKeyEvents/moMouseClickAreas.lua");
		source(MultiOverlayV2.modDir.."scripte/mouseKeyEvents/moSetGetKeyMouseEvent.lua");
		source(MultiOverlayV2.modDir.."scripte/mouseKeyEvents/moDragDrop.lua");
		source(MultiOverlayV2.modDir.."scripte/moSetGetVehicles.lua");
		source(MultiOverlayV2.modDir.."scripte/moSetGetArtDesign.lua");
		source(MultiOverlayV2.modDir.."scripte/moSetGetGui.lua");
		source(MultiOverlayV2.modDir.."scripte/moSetGetAmount.lua");
		source(MultiOverlayV2.modDir.."scripte/moSetGetDemandSales.lua");
		source(MultiOverlayV2.modDir.."scripte/moSetGetBga.lua");
		source(MultiOverlayV2.modDir.."scripte/moSetGetFields.lua");	
		source(MultiOverlayV2.modDir.."scripte/moSetGetSlotObjects.lua");
	end;
end;


function testFunction(self)
	--g_i18n:formatNumber(capacity)
	--g_currentMission:addWarning(g_i18n:getText(FruitUtil.fruitIndexToDesc[fruitType].name) .. g_i18n:getText("notAcceptedHere"), 0.018, 0.033);
	--currentPalletFillPercentage    --woolpallet check laut gigant :-(
	--isMouseCursorVisible
	--numObjectsInPalletSpawnerTrigger, sheep !	
	print("testFunction..............")	
	-------------------------	
	--noch schreiben	
end;

function testFunction1(check1, check2, check3, check4)	
	local calculation3 = true;
	local mapSize = 1;
	local terrainHeight = getTerrainHeightAtWorldPos(g_currentMission.terrainRootNode, -1026, 0, -1026);
	if terrainHeight ~= nil and terrainHeight ~= 0 then mapSize = 2;end;
	local terrainSize = g_currentMission.terrainSize --*mapSize; -- -2
	local mapOffset = terrainSize/2;
	--print("terrainSize....mapOffset.....".. tostring(terrainSize).. " - ".. tostring(mapOffset))		
	if calculation3 then		
		if check1 then			
			print("-----------------------------------------------------------------")
			print("Begin.. search world fields: ".. tostring(moGuiExtras:getRealTime(true, true, true)))
			print("   search World/Fieldsareas....")
			function getMapIndicator()
				moFieldMapIndicator = {};
				for fieldNumber,fieldDef in ipairs(g_currentMission.fieldDefinitionBase.fieldDefs) do
					if fieldDef.fieldMapIndicator ~= nil then
						local wx, _, wz = getWorldTranslation(fieldDef.fieldMapIndicator);
						if wx ~= nil and wz ~= nil then
							moFieldMapIndicator[fieldNumber] = {};
							moFieldMapIndicator[fieldNumber].x = wx;
							moFieldMapIndicator[fieldNumber].z = wz;						
						end;
					end;					
				end;
			end;
			getMapIndicator();
			moWorldLine = {};
			--local x1, _, z1 = getWorldTranslation(-725, -725)
			--local world = true; --Utils.getIsWorldPositionInCompressionRange(-725, -725)
			--print("x.........z....".. tostring(x1).. " - ".. tostring(z1).. " - ".. tostring(world))			
			function isField(x, z, wx, wz)
				if x == nil or z == nil or wx == nil or wz == nil then
					return false;
				end;
				local denW = 0;
				local widthX, widthZ = x - wx, z - wz;
				local heightX, heightZ = x + wx, z + wz;
				local wX, wZ, wWX, wWZ, wHX, wHZ = Utils.getXZWidthAndHeight(g_currentMission.terrainDetailId, x, z, widthX, widthZ, heightX, heightZ);
				local denW = getDensityAtWorldPos(g_currentMission.terrainDetailId, wX, wZ);
				return denW > 0;
			end;
			indenticalNum = {};		
			local scanVector = 3*mapSize; --3 good --height plus, width minus			
			local vectorNum = 0;
			local nextVectorNum = false;
			local count = 0;
			local count1 = 0;
			local lineZ = 0;
			local foundLineField = 0;
			local fieldFoundAreas = 0;			
			local worldStartX = mapOffset-(mapOffset*2);
			local worldEndX = mapOffset;
			local worldStartZ = mapOffset-(mapOffset*2);
			local worldEndZ = mapOffset;
			local lastLineVector = 0;
			local nextLastLineVector = false;
			function scanLine(z)			
				for x=worldStartX, worldEndX, scanVector do
					--local z = startZ;
					count1 = count1+1;
					local vectorString = tostring(x).. ",".. tostring(z).. ",".. tostring(x-(scanVector/2)).. ",".. tostring(z-(scanVector/2)).. ",".. tostring(x+(scanVector/2)).. ",".. tostring(z+(scanVector/2))
					--local fieldFound = isField(x, z, x-(scanVector/2), z-(scanVector/2), x+(scanVector/2), z+(scanVector/2));
					local fieldFound = isField(x, z, scanVector/2, scanVector/2)
					--local fieldNumber, isField = getField(x, z, x+(scanVector/2), z+(scanVector/2), x-(scanVector/2), z-(scanVector/2))
					if fieldFound then						
						nextLastLineVector = true;
						moWorldLine[lineZ][vectorString] = {};
						moWorldLine[lineZ][vectorString].vectorString = vectorString;					
						if nextVectorNum then vectorNum = vectorNum+1;nextVectorNum = false;end;						
						function getLowerVectorFromString(vectorString)
							local vectorString = Utils.splitString(",", vectorString);
							return tostring(vectorString[1]).. ",".. tostring(vectorString[2]-scanVector).. ",".. tostring(vectorString[3]).. ",".. tostring(vectorString[4]-scanVector).. ",".. tostring(vectorString[5]).. ",".. tostring(vectorString[6]-scanVector);
						end;
						function getFieldNumber(x1, x2, z1, z2)
							local fieldNumber = 0;
							for a=1, moFields.fieldsMax do
								if moFieldMapIndicator[a] ~= nil and moFieldMapIndicator[a].x ~= nil and moFieldMapIndicator[a].z ~= nil then								
									--moFieldNum[field][a].x1 >= x and x >= moFieldNum[field][a].x2 and moFieldNum[field][a].z1 >= z and z >= moFieldNum[field][a].z2 then
									if x1 <= moFieldMapIndicator[a].x and moFieldMapIndicator[a].x <= x2 and z1 <= moFieldMapIndicator[a].z and moFieldMapIndicator[a].z <= z2 then
										fieldNumber = a;
										break;
									end;
								end;
							end;
							return fieldNumber;
						end;					
						local fieldNum = getFieldNumber(x-(scanVector/2), x+(scanVector/2), z-(scanVector/2), z+(scanVector/2));						
						local stringFieldNum = "f".. tostring(fieldNum).. ",";
						--print("fieldnumber..........".. tostring(stringFieldNum))
						local lowerVectorNum = 0;															
						if lastLineVector == lineZ-1 then
							local lowerVector = getLowerVectorFromString(vectorString);
							if moWorldLine[lineZ-1] ~= nil and moWorldLine[lineZ-1][lowerVector] ~= nil and moWorldLine[lineZ-1][lowerVector].vectorNum ~= 0 then lowerVectorNum = moWorldLine[lineZ-1][lowerVector].vectorNum;end;						
						end;						
						local stringVectorNum = tostring(vectorNum).. ",";
						local deleteIndenticalNum = false;
						if lowerVectorNum ~= 0 then
							local stringLowerVectorNum = tostring(lowerVectorNum).. ",";
							local foundNum = false;
							if table.getn(indenticalNum) > 0 then
								for a=1, table.getn(indenticalNum) do
									if string.find(indenticalNum[a], ",".. stringLowerVectorNum) then	
										if string.find(indenticalNum[a], ",".. stringVectorNum) then 
											if fieldNum ~= 0 then																				
												if not string.find(indenticalNum[a], stringFieldNum) then									
													indenticalNum[a] = indenticalNum[a].. stringFieldNum;								
												end;
											end;
											foundNum = true;
											break;
										end;
										if indenticalNum[a] == nil then indenticalNum[a] = ",";end;
										indenticalNum[a] = indenticalNum[a].. stringVectorNum;
										if fieldNum ~= 0 then																				
											if not string.find(indenticalNum[a], stringFieldNum) then									
												indenticalNum[a] = indenticalNum[a].. stringFieldNum;								
											end;
										end;
										foundNum = true;
										break;
									end;
								end;
							end;
							if not foundNum then 								
								indenticalNum[#indenticalNum+1] = ",".. stringVectorNum;									
								--print("not foundNum 1....".. tostring(stringVectorNum))
							else
								for a=1, table.getn(indenticalNum) do
									if string.find(indenticalNum[a], ",".. stringVectorNum) then										
										local splitStringVectorNum = Utils.splitString(",", indenticalNum[a]);
										if #splitStringVectorNum == 3 then indenticalNum[a] = nil;deleteIndenticalNum = true;end;
									end;
								end;
							end;
						else
							if table.getn(indenticalNum) > 0 then
								local foundNum = false;
								for a=1, table.getn(indenticalNum) do
									if string.find(indenticalNum[a], ",".. stringVectorNum) then										
										foundNum = true;
										break;
									end;
								end;
								if not foundNum then									
									indenticalNum[#indenticalNum+1] = ",".. stringVectorNum;										
									--print("not foundNum 2....".. tostring(stringVectorNum))
								end;
							else								
								indenticalNum[#indenticalNum+1] = ",".. stringVectorNum;
								--print("not foundNum 3....".. tostring(stringVectorNum))
							end;
						end;							
						moWorldLine[lineZ][vectorString].vectorNum = vectorNum;						
						fieldFoundAreas = fieldFoundAreas+1;						
					else
						nextVectorNum = true;
					end;
				end;
				if nextLastLineVector then
					nextLastLineVector = false;
					lastLineVector = lineZ;
				end;				
			end;
			for z=worldStartZ, worldEndZ, scanVector do			
				lineZ = lineZ+1
				moWorldLine[lineZ] = {};				
				nextVectorNum = true;
				scanLine(z);						
				count = count+1;				
			end;			
			print("   Found Worldareas Z(".. tostring(count).. ") - Worldareas X(".. tostring(count1).. ") - Fields found areas(".. tostring(fieldFoundAreas).. ")")
			print("   End.. search World/Fieldsareas: ".. tostring(moGuiExtras:getRealTime(true, true, true)))			
			moGuiMiniPdaSlots.fieldsInfo.isUpdateWorldAreasScanTime = 0;
			moGuiMiniPdaSlots.fieldsInfo.isUpdateWorldAreasScan = 2;
			moGuiMiniPdaSlots.fieldsInfo.isUpdateWorldAreasScanText = "search fieldsareas home garden....";
		end;
		function getLastVectorFromString(vectorString)
			local vectorString = Utils.splitString(",", vectorString);
			return tostring(vectorString[1]-scanVector).. ",".. tostring(vectorString[2]).. ",".. tostring(vectorString[3]-scanVector).. ",".. tostring(vectorString[4]).. ",".. tostring(vectorString[5]-scanVector).. ",".. tostring(vectorString[6]);
		end;
		function getNextVectorFromString(vectorString)
			local vectorString = Utils.splitString(",", vectorString);
			return tostring(vectorString[1]+scanVector).. ",".. tostring(vectorString[2]).. ",".. tostring(vectorString[3]+scanVector).. ",".. tostring(vectorString[4]).. ",".. tostring(vectorString[5]+scanVector).. ",".. tostring(vectorString[6]);
		end;
		function getVectorFromString(vectorString)
			local vectorString = Utils.splitString(",", vectorString);
			return tonumber(vectorString[1]), tonumber(vectorString[2]), tonumber(vectorString[3]), tonumber(vectorString[4]), tonumber(vectorString[5]), tonumber(vectorString[6]);
		end;
		if check2 and moWorldLine ~= nil then			
			print("   search fieldsareas home garden....")
			--check noField vector
			for a=1, table.getn(indenticalNum) do
				if indenticalNum[a] ~= nil then
					if not string.find(indenticalNum[a], "f") then
						local vectorField = Utils.splitString(",", indenticalNum[a]);
						local searchNext = false;
						for b=1, #vectorField do
							if searchNext then break;end;
							for c=1, table.getn(indenticalNum) do
								if searchNext then break;end;
								if indenticalNum[c] ~= nil then
									if string.find(indenticalNum[c], ",".. vectorField[b].. ",") then										
										local vectorAndField = Utils.splitString(",", indenticalNum[c]);
										if vectorAndField ~= nil and #vectorAndField > 0 then
											local fieldNum = nil;
											for f=1, #vectorAndField do
												if string.find(vectorAndField[f], "f") then													
													fieldNum = vectorAndField[f].. ",";													
												end;
											end;
											if fieldNum ~= nil then
												local newVectorString = string.gsub(indenticalNum[a], ",".. vectorField[b].. ",", ",");
												indenticalNum[a] = newVectorString.. fieldNum;
												--indenticalNum[a] = indenticalNum[a].. fieldNum;
												searchNext = true;
											end;
										end;
									end;
								end;
							end;
						end;
					end;
				end;
			end;			
			moGuiMiniPdaSlots.fieldsInfo.isUpdateWorldAreasScanTime = 0;
			moGuiMiniPdaSlots.fieldsInfo.isUpdateWorldAreasScan = 3;
			moGuiMiniPdaSlots.fieldsInfo.isUpdateWorldAreasScanText = "generate fieldsdata....";
			--check noField vector				
		end;		
		if check3 and moWorldLine ~= nil then			
			print("   generate fieldsdata....")
			moFieldDefNew = {};
			--generate Fields
			for a=1, moFields.fieldsMax do
				if moFieldDefNew[a] ~= nil then moFieldDefNew[a] = nil;end;
				moFieldDefNew[a] = {};
			end;
			--generate Fields					
			function getVectorNumIdentical(stringVectorNum)
				local vectorNum = nil;
				local fieldNumTable = nil;
				local fieldNumString = nil;
				for a=1, table.getn(indenticalNum) do					
					if indenticalNum[a] ~= nil then	
						if string.find(indenticalNum[a], ",".. tostring(stringVectorNum).. ",") then 
							if not string.find(indenticalNum[a], "f") then break;end;
							local vectorAndField = Utils.splitString(",", indenticalNum[a]);
							if vectorAndField ~= nil and #vectorAndField > 0 then
								local fieldNumFound = {};
								for f=1, #vectorAndField do									
									if string.find(vectorAndField[f], "f") then										
										local convertString = tostring(string.gsub(vectorAndField[f], "f", ""));
										if type(tonumber(convertString)) ~= nil then											
											fieldNumFound[#fieldNumFound+1] = tonumber(convertString);
										end;										
									end;									
								end;
								if #fieldNumFound > 0 then fieldNumTable = fieldNumFound;end;
							end;
							vectorNum = a;
							break;
						end;
					end;
				end;				
				return vectorNum, fieldNumTable;
			end;
			for a=1, table.getn(moWorldLine) do				
				for k,v in pairs(moWorldLine[a]) do
					if k ~= nil and moWorldLine[a][k] == nil then break;end;
					local defNum, fieldNumTable = getVectorNumIdentical(moWorldLine[a][k].vectorNum);					
					if defNum ~= nil and fieldNumTable ~= nil then						
						local x, z, x1, z1, x2, z2 = getVectorFromString(moWorldLine[a][k].vectorString);					
						for f=1, #fieldNumTable do
							--print("fieldnumber....line ".. tostring(a).. " - ".. tostring(fieldNumTable[f]))
							table.insert(moFieldDefNew[fieldNumTable[f]], {x=x,z=z,x1=x1,z1=z1,x2=x2,z2=z2});							
							if moFieldDefNew[fieldNumTable[f]].fieldNum == nil then 
								moFieldDefNew[fieldNumTable[f]].fieldNum = ",".. tostring(fieldNumTable[f].. ",");
								moFieldDefNew[fieldNumTable[f]].sqm = moFields[fieldNumTable[f]].sqm;
							else
								for fs=1, #fieldNumTable do
									if not string.find(moFieldDefNew[fieldNumTable[f]].fieldNum, ",".. tostring(fieldNumTable[fs].. ",")) then
										moFieldDefNew[fieldNumTable[f]].fieldNum = moFieldDefNew[fieldNumTable[f]].fieldNum.. tostring(fieldNumTable[fs]).. ",";
										moFieldDefNew[fieldNumTable[f]].sqm = moFieldDefNew[fieldNumTable[f]].sqm+moFields[fieldNumTable[fs]].sqm;
									end;
								end;
							end;
						end;												
					end;
				end;				
			end;
			print("   End.. generate fieldsdata")			
			moGuiMiniPdaSlots.fieldsInfo.isUpdateWorldAreasScanTime = 0;
			moGuiMiniPdaSlots.fieldsInfo.isUpdateWorldAreasScan = 4;		
			--for a=1, table.getn(indenticalNum) do			
			--	local vectorNum = "0";			
			--	if indenticalNum[a] ~= nil then vectorNum = tostring(indenticalNum[a]);end;
			--	print("indenticalNum.......".. tostring(vectorNum))
			--end;
		end;
				
	end;
	if moGuiMiniPdaSlots.fieldsInfo.isUpdateWorldAreasScan == 4 then
		print("End.. search world fields: ".. tostring(moGuiExtras:getRealTime(true, true, true)))
		print("-----------------------------------------------------------------")		
		moWorldLine = nil;
		indenticalNum = nil;
		moGuiMiniPdaSlots.fieldsInfo.isUpdate = false;
		moGuiMiniPdaSlots.fieldsInfo.isUpdateWorldAreas = true;
		moGuiMiniPdaSlots.fieldsInfo.isUpdateWorldAreasScanText = "search world/fieldsareas";
		moGuiMiniPdaSlots.fieldsInfo.isUpdateWorldAreasScan = 1;
		moGuiMiniPdaSlots.fieldsInfo.lastRefreshFieldsAreas = tostring(moGuiExtras:getMilliSecondsToHours(g_currentMission.environment.dayTime, true));
		--print(tostring(MultiOverlayV2:tableToString(moFieldDefNew[28])));
		--moSetGetFields:setFieldsInfoUpdate(self);
	end;
	moGuiMiniPdaSlots.fieldsInfo.isUpdateWorldAreasScanTime = 0;
end;


function MultiOverlayV2:debug(file, txt)
	print("Debug MultiOverlayV2 Hud.......begin...")
	print(tostring(MultiOverlayV2:tableToString(moGuiMiniPdaSlots.values)));	
	print("moddir ".. tostring(MultiOverlayV2.modDir))
	print("settingsdir ".. tostring(MultiOverlayV2.settingsDir))
	print("detiServerDir ".. tostring(MultiOverlayV2.detiServerDir))
	print("gamedir ".. tostring(MultiOverlayV2.gameDir))
	print("savegamedir ".. tostring(MultiOverlayV2.savegameDir))
	print("language ".. tostring(MultiOverlayV2.language))
	print("loaderror ".. tostring(MultiOverlayV2.loadError))
	print("loadHostMp ".. tostring(MultiOverlayV2.loadHostMp))
	print("isMp ".. tostring(MultiOverlayV2.isMp))
	print("isServer ".. tostring(MultiOverlayV2.isServer))
	print("isClient ".. tostring(MultiOverlayV2.isClient))		
	print("Debug MultiOverlayV2 Hud.......end.....")
end;

function MultiOverlayV2:tableToString(tt, indent, done)
	--print(tostring(MultiOverlayV2:tableToString(...)));
	--for key, value in pairs(.....) do
	--	print("key und value ...".. tostring(key).. "-----".. tostring(value))
	--end;	
	done = done or {}
	indent = indent or 0
	if type(tt) == "table" then
		local sb = {}
		for key, value in pairs (tt) do
			table.insert(sb, string.rep (" ", indent))
			if type (value) == "table" and not done [value] then
				done [value] = true
				table.insert(sb, "{\n");
				table.insert(sb, MultiOverlayV2:tableToString (value, indent + 2, done))
				table.insert(sb, string.rep (" ", indent))
				table.insert(sb, "}\n");
			elseif "number" == type(key) then
				table.insert(sb, string.format("\"%s\"\n", tostring(value)))
			else
				table.insert(sb, string.format("%s = \"%s\"\n", tostring(key), tostring(value)))
			end
		end
		return table.concat(sb)
	else
		if tt == nil then return "table error.........";end;
		return tt .. "\n"
	end
end

-----------------------------
MultiOverlayV2Event = {};
MultiOverlayV2Event_mt = Class(MultiOverlayV2Event, Event);
InitEventClass(MultiOverlayV2Event, "MultiOverlayV2Event");

function MultiOverlayV2Event:emptyNew()    
	local self = Event:new(MultiOverlayV2Event_mt);
    self.className="MultiOverlayV2Event";
    return self;
end;

function MultiOverlayV2Event:new(greatDemandNew, discountNew, saveWeatherNew, weatherDaysStringNew, infoNew, infoEditUserNew, infoEditPwNew, noEventSend)    	
	local self = MultiOverlayV2Event:emptyNew();
	self.greatDemand_s = greatDemandNew;
	self.discount_s = discountNew;
	self.saveWeather_s = saveWeatherNew;
	self.weatherDaysString_s = weatherDaysStringNew;
	self.info_s = infoNew;
	self.infoEditUser_s = infoEditUserNew;
	self.infoEditPw_s = infoEditPwNew;
	MultiOverlayV2.event.login = noEventSend;	
    return self;
end;

function MultiOverlayV2Event:readStream(streamId, connection)    
	self.greatDemand_s = streamReadBool(streamId); 
	self.discount_s = streamReadBool(streamId);
	self.saveWeather_s = streamReadBool(streamId);
	self.weatherDaysString_s = streamReadString(streamId);
	self.info_s = streamReadBool(streamId);
	self.infoEditUser_s = streamReadInt32(streamId);
	self.infoEditPw_s = streamReadString(streamId);
    MultiOverlayV2.event.login = streamReadBool(streamId);	
	self:run(connection);
end;

function MultiOverlayV2Event:writeStream(streamId, connection)    	
	streamWriteBool(streamId, self.greatDemand_s);
	streamWriteBool(streamId, self.discount_s);
	streamWriteBool(streamId, self.saveWeather_s);
	streamWriteString(streamId, self.weatherDaysString_s);
	streamWriteBool(streamId, self.info_s);
	streamWriteInt32(streamId, self.infoEditUser_s);
	streamWriteString(streamId, self.infoEditPw_s);
	streamWriteBool(streamId, MultiOverlayV2.event.login); 
end;

function MultiOverlayV2Event:run(connection)
	if self.greatDemand_s ~= nil and not MultiOverlayV2.event.login and not MultiOverlayV2.event.isMpUpdate then		
		self.greatDemand_s = self.greatDemand_s;
		self.discount_s = self.discount_s;
		self.saveWeather_s = self.saveWeather_s;
		self.weatherDaysString_s = self.weatherDaysString_s;
		self.info_s = self.info_s;
		self.infoEditUser_s = self.infoEditUser_s;
		self.infoEditPw_s = self.infoEditPw_s;
		self:setGreatDemandDiscountEvent(self.greatDemand_s, self.discount_s, self.saveWeather_s, self.weatherDaysString_s, self.info_s, self.infoEditUser_s, self.infoEditPw_s, true);		
	end;
	if MultiOverlayV2.event.login and not MultiOverlayV2.event.isMpUpdate then		
		self.greatDemand_s = MultiOverlayV2.event.greatDemand_s;
		self.discount_s = MultiOverlayV2.event.discount_s;
		self.saveWeather_s = MultiOverlayV2.event.saveWeather_s;
		self.weatherDaysString_s = MultiOverlayV2.event.weatherDaysString_s;
		self.info_s = MultiOverlayV2.event.info_s;
		self.infoEditUser_s = MultiOverlayV2.event.infoEditUser_s;
		self.infoEditPw_s = MultiOverlayV2.event.infoEditPw_s;
		MultiOverlayV2Event.sendEvent(self.greatDemand_s, self.discount_s, self.saveWeather_s, self.weatherDaysString_s, self.info_s, self.infoEditUser_s, self.infoEditPw_s, false);		
	end;
end;

function MultiOverlayV2Event.sendEvent(greatDemandNew, discountNew, saveWeatherNew, weatherDaysStringNew, infoNew, infoEditUserNew, infoEditPwNew, noEventSend)		
	if g_server ~= nil and g_server ~= false and not noEventSend then		
		g_server:broadcastEvent(MultiOverlayV2Event:new(greatDemandNew, discountNew, saveWeatherNew, weatherDaysStringNew, infoNew, infoEditUserNew, infoEditPwNew, false), nil, nil, nil);		
	end;
	if g_server == nil and noEventSend then		
		g_client:getServerConnection():sendEvent(MultiOverlayV2Event:new(greatDemandNew, discountNew, saveWeatherNew, weatherDaysStringNew, infoNew, infoEditUserNew, infoEditPwNew, true));
	end;
end;

function MultiOverlayV2Event:setGreatDemandDiscountEvent(greatDemandNew, discountNew, saveWeatherNew, weatherDaysStringNew, infoNew, infoEditUserNew, infoEditPwNew, noEventSend)	
		
	if greatDemandNew ~= nil then MultiOverlayV2.event.greatDemand_s = greatDemandNew;end;
	if discountNew ~= nil then MultiOverlayV2.event.discount_s = discountNew;end;
	if saveWeatherNew ~= nil then MultiOverlayV2.event.saveWeather_s = saveWeatherNew;end;
	if weatherDaysStringNew ~= nil and MultiOverlayV2.event.saveWeather_s then	
		MultiOverlayV2.event.weatherDaysString_s = weatherDaysStringNew;
		MultiOverlayV2Event:setServerWeather(self);
	end;
	if infoNew ~= nil then MultiOverlayV2.event.info_s = infoNew;end;
	if infoEditUserNew ~= nil then MultiOverlayV2.event.infoEditUser_s = infoEditUserNew;end;
	if infoEditPwNew ~= nil then MultiOverlayV2.event.infoEditPw_s = infoEditPwNew;end;
	MultiOverlayV2.event.isMpUpdate = true;
end;

function MultiOverlayV2Event:setServerWeather(self)
	print(tostring(MultiOverlayV2.metadata.title).. " ....update server weather....");	
	if string.len(MultiOverlayV2.event.weatherDaysString_s) > 0 then
		local serverDays = Utils.splitString("Day:", MultiOverlayV2.event.weatherDaysString_s);							
		local errorWeather = false;
		local a = 1;
		for k,v in pairs(serverDays) do
			local serverDay = Utils.splitString(" ", v);
			if serverDay[1] ~= nil and serverDay[2] ~= nil and serverDay[3] ~= nil then
				MultiOverlayV2.event.weatherDays_s[a] = {};
				MultiOverlayV2.event.weatherDays_s[a].tempDay = tonumber(serverDay[1]);
				MultiOverlayV2.event.weatherDays_s[a].tempNight = tonumber(serverDay[2]);
				MultiOverlayV2.event.weatherDays_s[a].weatherType = tostring(serverDay[3]);
				a = a+1;			
			end;
		end;
		if a >= 14 then
			print("update server weather complete");
			MultiOverlayV2.event.loadWeather_s = true;
			moGuiExtras:loadSaveWeather(self, true, false);
		else
			print("ERROR.....update server weather failed");
		end;
	end;
end;
---------------
function MultiOverlayV2:loadWeatherServer(self, singlePlayer)
	if MultiOverlayV2.isMp and g_server ~= nil and g_client ~= nil and MultiOverlayV2.event.saveWeather_s or singlePlayer then
		local file = MultiOverlayV2.pathSavegame.. "/mohV2weatherSettings.xml"; 		
		local firstSave = false;
		local tableXml = MultiOverlayV2.event.weatherDays_s;
		--if singlePlayer then tableXml = moSetGetGui.wtmHud.weatherDays;end;
		if fileExists(file) then
			print("loading "..file.." for MultiOverlayV2 weather settings");		
			Xml = loadXMLFile("MultiOverlayV2_XML", file, "weatherSave");
			local b = 0;
			for a=1, 14 do
				groupNameTag = ("weatherSave.values(%d)"):format(a-1);
				local idx = getXMLInt(Xml, groupNameTag.."#day");
				if idx == nil or groupNameTag == nil then
					break;
				end;
				tableXml[a] = {};
				if getXMLInt(Xml, groupNameTag.."#tempD") and getXMLInt(Xml, groupNameTag.."#tempN") and getXMLString(Xml, groupNameTag.. "#type") ~= nil then					
					tableXml[a].tempDay = getXMLInt(Xml, groupNameTag.."#tempD");					
					tableXml[a].tempNight = getXMLInt(Xml, groupNameTag.."#tempN");					
					tableXml[a].weatherType = getXMLString(Xml, groupNameTag.. "#type");
					MultiOverlayV2.event.weatherDaysString_s = MultiOverlayV2.event.weatherDaysString_s.. "Day:".. tostring(tableXml[a].tempDay).. " ".. tostring(tableXml[a].tempNight).. " ".. tostring(tableXml[a].weatherType).. " ";
					b = b+1;					
				end;
			end;
			if b == 14 then 
				MultiOverlayV2.event.loadWeather_s = true;
				--if not singlePlayer then MultiOverlayV2.event.loadWeather_s = true;end;
				moGuiExtras:loadSaveWeather(self, true, false);
				--if not singlePlayer then moGuiExtras:loadSaveWeather(self, true, true);end;
				MultiOverlayV2:saveBackup(file, MultiOverlayV2.detiServerDir, false);
			end;
		else
			if not fileExists(MultiOverlayV2.pathSavegame.. "/careerSavegame.xml") then				
				firstSave = true;
				--file = MultiOverlayV2.detiServerDir.."/savegameBackup/mohV2weatherSettings.xml";
			end;
			if firstSave then 
				--print("creating New "..file.." for MultiOverlayV2 weather settings")
				--MultiOverlayV2:saveWeatherServer(self, singlePlayer);
			end;			
		end;			
		if not firstSave then
			--MultiOverlayV2:saveBackup(file, MultiOverlayV2.detiServerDir);
		end;			
	end;
end;

function MultiOverlayV2:saveWeatherServer(self, singlePlayer)
	if MultiOverlayV2.event.saveWeather_s and MultiOverlayV2.event.loadWeather_s or singlePlayer then		
		local file = MultiOverlayV2.pathSavegame.. "/mohV2weatherSettings.xml"; 
		local Xml = createXMLFile("MultiOverlayV2_XML", file, "weatherSave");
		local tableXml = MultiOverlayV2.event.weatherDays_s;
		--if singlePlayer then tableXml = moSetGetGui.wtmHud.weatherDays;end;
		for a=1, 14 do	
			local groupNameTag = ("weatherSave.values(%d)"):format(a-1);
			setXMLInt(Xml, groupNameTag.."#day", a);
			setXMLInt(Xml, groupNameTag.. "#tempD", tableXml[a].tempDay);
			setXMLInt(Xml, groupNameTag.. "#tempN", tableXml[a].tempNight);
			setXMLString(Xml, groupNameTag.. "#type", tableXml[a].weatherType);
		end;
		saveXMLFile(Xml);
		MultiOverlayV2:saveBackup(file, MultiOverlayV2.detiServerDir, false);
	end;
end;

function MultiOverlayV2:saveInfoServer(self)
	if #MultiOverlayV2.event.infoTable_s > 0 then
		local file = MultiOverlayV2.pathSavegame.. "/mohV2infoSettings.xml"; 
		local Xml = createXMLFile("MultiOverlayV2_XML", file, "infoSave");
		local tableXml = MultiOverlayV2.event.infoTable_s;
		for a=1, #MultiOverlayV2.event.infoTable_s do
			local groupNameTag = ("infoSave.values(%d)"):format(a-1);
			setXMLInt(Xml, groupNameTag.."#info", a);
			setXMLString(Xml, groupNameTag.. "#text", tableXml[a].text);
			setXMLString(Xml, groupNameTag.. "#createUser", tableXml[a].createUser);
			setXMLString(Xml, groupNameTag.. "#createDate", tableXml[a].createDate);			
			setXMLString(Xml, groupNameTag.. "#inProgressUser", tableXml[a].inProgressUser);
			setXMLString(Xml, groupNameTag.. "#doneUser", tableXml[a].doneUser);			
		end;
		saveXMLFile(Xml);
		MultiOverlayV2:saveBackup(file, MultiOverlayV2.detiServerDir, true);
	end;
end;

--Savegame made by HappLooser...--
function MultiOverlayV2:saveBackup(file, path, info)
	if g_server == nil then return;end;
	local fileBackup;
	if not info then
		fileBackup = path.."/savegameBackup/mohV2weatherSettings.xml";	
		copyFile(file, fileBackup);
	end;
	if info then
		fileBackup = path.."/savegameBackup/mohV2infoSettings.xml";	
		copyFile(file, fileBackup);
	end;
end;

local function getXMLBack(self)	
	if g_server == nil then return end;	
	local fileBackup;
	local file;
	if MultiOverlayV2.event.loadWeather_s then
		fileBackup = MultiOverlayV2.detiServerDir.."/savegameBackup/mohV2weatherSettings.xml";
		file = MultiOverlayV2.pathSavegame.. "/mohV2weatherSettings.xml";
		if fileExists(MultiOverlayV2.pathSavegame.. "/careerSavegame.xml") and fileExists(fileBackup) then
			copyFile(fileBackup, file);
		end;
	end;
	if MultiOverlayV2.event.info_s then
		fileBackup = MultiOverlayV2.detiServerDir.."/savegameBackup/mohV2infoSettings.xml";
		file = MultiOverlayV2.pathSavegame.. "/mohV2infoSettings.xml";
		if fileExists(MultiOverlayV2.pathSavegame.. "/careerSavegame.xml") and fileExists(fileBackup) then
			copyFile(fileBackup, file);
		end;
	end;	
end;
g_careerScreen.saveSavegame = Utils.appendedFunction(g_careerScreen.saveSavegame, getXMLBack);
--Savegame made by HappLooser...--